%%  NOTE: *** Participants SHOULD modify this file ***
%                          ------

 % TODO: Comment key parameters/variables.

%=========================================================================%
%                          Build Nominal Plant
%=========================================================================%
% The LQG controller algorightm requires a model of the plant to realize a
% a control law. Typically, a model is identified from experimental data.
% The nominal model (which is an identified model of the plant) provided
% in this Benchmark will be considered for this purpose.

    A = plantFRAME_SS.a; B = plantFRAME_SS.b; C = plantFRAME_SS.c; D = plantFRAME_SS.d;

%=========================================================================%
%                   Kalman filter - Estimation of states
%=========================================================================%
    %{
    Augmented plant:
    xdot = A*x + [B G]*[u w]'
    y = C*x + [D E]*[u w]'
    %}

    Q = eye(size(A));                       % Process noise covariance
    gainQ = 1*diag([1 1 1 1 1 1 0.01 1]);
    R = diag([1 1]);                        % Measurement noise covariance
    gainR = 100*diag([1 1]); 
    N = 0;                                  % Noise cross covariance
    %Note: See 'kalman' in the MATLAB documentation for more information.
    
    G = eye(size(A));    
    E = zeros(2,size(Q,2));
    aug_plant= ss(A,[B G],C,[D E]);
    
    [KE,~,~] = kalman(aug_plant,gainQ*Q,gainR*R,N);
    
%=========================================================================%
%                           Tracking LQG controller
%=========================================================================%

    % Augmented plant 
    Aaug = [A zeros(8,2);C zeros(2,2)];
    Baug = [B;D];
    
    % Defining coveriance matrix
    % See Sect. 5.3 of the paper
    gain_err_st_1 = 1;                      % Gain for error 1
    gain_err_st_2 = 1;                      % Gain for error 2
    gain_u1 = 0.001;        
    gain_u2 = 0.01;         
    
    Rc = diag([gain_u1 gain_u2]);
    Qc = [zeros(8,8) zeros(8,2); zeros(2,8) diag([gain_err_st_1 gain_err_st_2])];
    
    [K_lqr, ~, ~] = lqr(Aaug,Baug,Qc,Rc);
   
clear A B D C Q R N r  G E gainR gainQ aug_plant Aaug Baug ... 
      gain_int1 gain_int2 gain_u2 gain_u1 Rc Qc 
         
    